i18n: git-submodule "Submodule change[...]" messages
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
d27b876b 8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
9db31bdf 11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 13 or: $dashless [--quiet] foreach [--recursive] <command>
1d5bec8b 14 or: $dashless [--quiet] sync [--] [<path>...]"
8f321a39 15OPTIONS_SPEC=
70c7ac22 16. git-sh-setup
d0ad8251 17. git-sh-i18n
98fcf840 18. git-parse-remote
70c7ac22
LH
19require_work_tree
20
5c08dbbd 21command=
ecda0723 22branch=
d27b876b 23force=
d92a3959 24reference=
70c7ac22 25cached=
48bb3033
GP
26recursive=
27init=
1c244f6e 28files=
31ca3ac3 29nofetch=
32948425 30update=
15fc56a8 31prefix=
70c7ac22 32
f31a522a
ML
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
98fcf840 36 remote=$(get_default_remote)
8e7e6f39 37 remoteurl=$(git config "remote.$remote.url") ||
497ee872 38 die "$(eval_gettext "remote (\$remote) does not have a url defined in .git/config")"
f31a522a 39 url="$1"
99b120af 40 remoteurl=${remoteurl%/}
ea640cc6 41 sep=/
f31a522a
ML
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
ea640cc6
TR
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
497ee872 56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
ea640cc6
TR
57 ;;
58 esac
f31a522a
ML
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
ea640cc6 67 echo "$remoteurl$sep${url%/}"
f31a522a
ML
68}
69
a7b3269c
DA
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
313ee0d6
NMC
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
a7b3269c
DA
94}
95
941987a5
LH
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
537601ac 103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
fe22e542 104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
941987a5 107 test -z "$name" &&
497ee872 108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
941987a5
LH
109 echo "$name"
110}
33aa6fff
LH
111
112#
113# Clone a submodule
114#
23a485e3 115# Prior to calling, cmd_update checks that a possibly existing
ecda0723 116# path is not a git repository.
23a485e3 117# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
118# since it is the location of a new submodule.
119#
33aa6fff
LH
120module_clone()
121{
122 path=$1
123 url=$2
d92a3959 124 reference="$3"
33aa6fff 125
d92a3959
MT
126 if test -n "$reference"
127 then
128 git-clone "$reference" -n "$url" "$path"
129 else
130 git-clone -n "$url" "$path"
131 fi ||
497ee872 132 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
33aa6fff
LH
133}
134
ecda0723
SV
135#
136# Add a new submodule to the working tree, .gitmodules and the index
137#
ec05df35 138# $@ = repo path
ecda0723
SV
139#
140# optional branch is stored in global branch variable
141#
23a485e3 142cmd_add()
ecda0723 143{
5c08dbbd
JH
144 # parse $args after "submodule ... add".
145 while test $# -ne 0
146 do
147 case "$1" in
148 -b | --branch)
149 case "$2" in '') usage ;; esac
150 branch=$2
151 shift
152 ;;
d27b876b
JL
153 -f | --force)
154 force=$1
155 ;;
5c08dbbd 156 -q|--quiet)
2e6a30ef 157 GIT_QUIET=1
5c08dbbd 158 ;;
d92a3959
MT
159 --reference)
160 case "$2" in '') usage ;; esac
161 reference="--reference=$2"
162 shift
163 ;;
164 --reference=*)
165 reference="$1"
166 shift
167 ;;
5c08dbbd
JH
168 --)
169 shift
170 break
171 ;;
172 -*)
173 usage
174 ;;
175 *)
176 break
177 ;;
178 esac
179 shift
180 done
181
ecda0723
SV
182 repo=$1
183 path=$2
184
1414e578
JL
185 if test -z "$path"; then
186 path=$(echo "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
188 fi
189
ec05df35 190 if test -z "$repo" -o -z "$path"; then
ecda0723
SV
191 usage
192 fi
193
ec05df35
ML
194 # assure repo is absolute or relative to parent
195 case "$repo" in
196 ./*|../*)
197 # dereference source url relative to parent's url
198 realrepo=$(resolve_relative_url "$repo") || exit
199 ;;
200 *:*|/*)
201 # absolute url
202 realrepo=$repo
203 ;;
204 *)
497ee872 205 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
206 ;;
207 esac
208
db75ada5
MG
209 # normalize path:
210 # multiple //; leading ./; /./; /../; trailing /
211 path=$(printf '%s/\n' "$path" |
212 sed -e '
213 s|//*|/|g
214 s|^\(\./\)*||
215 s|/\./|/|g
216 :start
217 s|\([^/]*\)/\.\./||
218 tstart
219 s|/*$||
220 ')
5be60078 221 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
497ee872 222 die "$(eval_gettext "'\$path' already exists in the index")"
ecda0723 223
d27b876b
JL
224 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
225 then
226 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
227 echo >&2 $path &&
228 echo >&2 "Use -f if you really want to add it."
229 exit 1
230 fi
231
d4264ca3
ML
232 # perhaps the path exists and is already a git repo, else clone it
233 if test -e "$path"
234 then
e9656473 235 if test -d "$path"/.git -o -f "$path"/.git
d4264ca3 236 then
dc2204fe 237 eval_gettext "Adding existing repo at '\$path' to the index"; echo
d4264ca3 238 else
497ee872 239 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
d4264ca3 240 fi
c2f93917
ML
241
242 case "$repo" in
243 ./*|../*)
244 url=$(resolve_relative_url "$repo") || exit
245 ;;
246 *)
247 url="$repo"
248 ;;
249 esac
250 git config submodule."$path".url "$url"
d4264ca3 251 else
d4264ca3 252
d92a3959 253 module_clone "$path" "$realrepo" "$reference" || exit
ea10b60c 254 (
74ae1419 255 clear_local_git_env
ea10b60c
BJ
256 cd "$path" &&
257 # ash fails to wordsplit ${branch:+-b "$branch"...}
258 case "$branch" in
259 '') git checkout -f -q ;;
502dc5b6 260 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 261 esac
497ee872 262 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
d4264ca3
ML
263 fi
264
d27b876b 265 git add $force "$path" ||
497ee872 266 die "$(eval_gettext "Failed to add submodule '\$path'")"
ecda0723 267
a5099bb4
IY
268 git config -f .gitmodules submodule."$path".path "$path" &&
269 git config -f .gitmodules submodule."$path".url "$repo" &&
31991b02 270 git add --force .gitmodules ||
497ee872 271 die "$(eval_gettext "Failed to register submodule '\$path'")"
ecda0723
SV
272}
273
19a31f9c
ML
274#
275# Execute an arbitrary command sequence in each checked out
276# submodule
277#
278# $@ = command to execute
279#
280cmd_foreach()
281{
1d5bec8b
JH
282 # parse $args after "submodule ... foreach".
283 while test $# -ne 0
284 do
285 case "$1" in
286 -q|--quiet)
287 GIT_QUIET=1
288 ;;
15fc56a8
JH
289 --recursive)
290 recursive=1
291 ;;
1d5bec8b
JH
292 -*)
293 usage
294 ;;
295 *)
296 break
297 ;;
298 esac
299 shift
300 done
301
f030c96d
ÆAB
302 toplevel=$(pwd)
303
a7b3269c 304 module_list |
19a31f9c
ML
305 while read mode sha1 stage path
306 do
307 if test -e "$path"/.git
308 then
15fc56a8 309 say "Entering '$prefix$path'"
1e7f2aad 310 name=$(module_name "$path")
15fc56a8
JH
311 (
312 prefix="$prefix$path/"
74ae1419 313 clear_local_git_env
15fc56a8
JH
314 cd "$path" &&
315 eval "$@" &&
316 if test -n "$recursive"
317 then
318 cmd_foreach "--recursive" "$@"
319 fi
320 ) ||
497ee872 321 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
19a31f9c
ML
322 fi
323 done
324}
325
70c7ac22 326#
211b7f19 327# Register submodules in .git/config
70c7ac22
LH
328#
329# $@ = requested paths (default to all)
330#
23a485e3 331cmd_init()
70c7ac22 332{
5c08dbbd
JH
333 # parse $args after "submodule ... init".
334 while test $# -ne 0
335 do
336 case "$1" in
337 -q|--quiet)
2e6a30ef 338 GIT_QUIET=1
5c08dbbd
JH
339 ;;
340 --)
341 shift
342 break
343 ;;
344 -*)
345 usage
346 ;;
347 *)
348 break
349 ;;
350 esac
351 shift
352 done
353
a7b3269c 354 module_list "$@" |
70c7ac22
LH
355 while read mode sha1 stage path
356 do
211b7f19 357 # Skip already registered paths
941987a5 358 name=$(module_name "$path") || exit
5be60078 359 url=$(git config submodule."$name".url)
211b7f19 360 test -z "$url" || continue
70c7ac22 361
a5099bb4 362 url=$(git config -f .gitmodules submodule."$name".url)
70c7ac22 363 test -z "$url" &&
497ee872 364 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
70c7ac22 365
f31a522a
ML
366 # Possibly a url relative to parent
367 case "$url" in
368 ./*|../*)
8e7e6f39 369 url=$(resolve_relative_url "$url") || exit
f31a522a
ML
370 ;;
371 esac
372
5be60078 373 git config submodule."$name".url "$url" ||
497ee872 374 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
70c7ac22 375
32948425
JH
376 upd="$(git config -f .gitmodules submodule."$name".update)"
377 test -z "$upd" ||
378 git config submodule."$name".update "$upd" ||
497ee872 379 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
ca2cedba 380
497ee872 381 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
70c7ac22
LH
382 done
383}
384
385#
211b7f19 386# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
387#
388# $@ = requested paths (default to all)
389#
23a485e3 390cmd_update()
70c7ac22 391{
5c08dbbd 392 # parse $args after "submodule ... update".
98dbe63d 393 orig_flags=
5c08dbbd
JH
394 while test $# -ne 0
395 do
396 case "$1" in
397 -q|--quiet)
2e6a30ef 398 GIT_QUIET=1
5c08dbbd 399 ;;
be4d2c83 400 -i|--init)
d92a3959 401 init=1
be4d2c83 402 ;;
31ca3ac3 403 -N|--no-fetch)
31ca3ac3
FF
404 nofetch=1
405 ;;
9db31bdf
NMC
406 -f|--force)
407 force=$1
408 ;;
ca2cedba 409 -r|--rebase)
32948425 410 update="rebase"
ca2cedba 411 ;;
d92a3959
MT
412 --reference)
413 case "$2" in '') usage ;; esac
414 reference="--reference=$2"
98dbe63d
KB
415 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
416 shift
d92a3959
MT
417 ;;
418 --reference=*)
419 reference="$1"
d92a3959 420 ;;
42b49178 421 -m|--merge)
42b49178
JH
422 update="merge"
423 ;;
b13fd5c1 424 --recursive)
b13fd5c1
JH
425 recursive=1
426 ;;
5c08dbbd
JH
427 --)
428 shift
429 break
430 ;;
431 -*)
432 usage
433 ;;
434 *)
435 break
436 ;;
437 esac
98dbe63d
KB
438 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
439 shift
5c08dbbd
JH
440 done
441
d92a3959
MT
442 if test -n "$init"
443 then
444 cmd_init "--" "$@" || return
445 fi
446
1b4735d9 447 cloned_modules=
a7b3269c 448 module_list "$@" |
70c7ac22
LH
449 while read mode sha1 stage path
450 do
313ee0d6
NMC
451 if test "$stage" = U
452 then
453 echo >&2 "Skipping unmerged submodule $path"
454 continue
455 fi
941987a5 456 name=$(module_name "$path") || exit
5be60078 457 url=$(git config submodule."$name".url)
32948425 458 update_module=$(git config submodule."$name".update)
211b7f19 459 if test -z "$url"
70c7ac22
LH
460 then
461 # Only mention uninitialized submodules when its
462 # path have been specified
463 test "$#" != "0" &&
989206f5 464 say "Submodule path '$path' not initialized" &&
be4d2c83 465 say "Maybe you want to use 'update --init'?"
211b7f19
LH
466 continue
467 fi
468
ba88a1fe 469 if ! test -d "$path"/.git -o -f "$path"/.git
211b7f19 470 then
d92a3959 471 module_clone "$path" "$url" "$reference"|| exit
1b4735d9 472 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
473 subsha1=
474 else
74ae1419 475 subsha1=$(clear_local_git_env; cd "$path" &&
5be60078 476 git rev-parse --verify HEAD) ||
497ee872 477 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
70c7ac22 478 fi
211b7f19 479
32948425 480 if ! test -z "$update"
ca2cedba 481 then
32948425 482 update_module=$update
ca2cedba
PH
483 fi
484
70c7ac22
LH
485 if test "$subsha1" != "$sha1"
486 then
9db31bdf
NMC
487 subforce=$force
488 # If we don't already have a -f flag and the submodule has never been checked out
489 if test -z "$subsha1" -a -z "$force"
b9b378a0 490 then
9db31bdf 491 subforce="-f"
b9b378a0 492 fi
31ca3ac3
FF
493
494 if test -z "$nofetch"
495 then
e5f522d6
JL
496 # Run fetch only if $sha1 isn't present or it
497 # is not reachable from a ref.
74ae1419 498 (clear_local_git_env; cd "$path" &&
e5f522d6
JL
499 ((rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
500 test -z "$rev") || git-fetch)) ||
497ee872 501 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
31ca3ac3
FF
502 fi
503
1b4735d9
SO
504 # Is this something we just cloned?
505 case ";$cloned_modules;" in
506 *";$name;"*)
507 # then there is no local change to integrate
508 update_module= ;;
509 esac
510
32948425
JH
511 case "$update_module" in
512 rebase)
513 command="git rebase"
ee653c89
ÆAB
514 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
515 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
32948425 516 ;;
42b49178
JH
517 merge)
518 command="git merge"
ee653c89
ÆAB
519 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
520 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
42b49178 521 ;;
32948425 522 *)
9db31bdf 523 command="git checkout $subforce -q"
ee653c89
ÆAB
524 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
525 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
32948425
JH
526 ;;
527 esac
70c7ac22 528
ee653c89
ÆAB
529 (clear_local_git_env; cd "$path" && $command "$sha1") || die $die_msg
530 say $say_msg
70c7ac22 531 fi
b13fd5c1
JH
532
533 if test -n "$recursive"
534 then
98dbe63d 535 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
497ee872 536 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
b13fd5c1 537 fi
70c7ac22
LH
538 done
539}
540
bffe71f4
EM
541set_name_rev () {
542 revname=$( (
74ae1419 543 clear_local_git_env
bffe71f4 544 cd "$1" && {
5be60078
JH
545 git describe "$2" 2>/dev/null ||
546 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
547 git describe --contains "$2" 2>/dev/null ||
548 git describe --all --always "$2"
bffe71f4
EM
549 }
550 ) )
551 test -z "$revname" || revname=" ($revname)"
552}
28f9af5d
PY
553#
554# Show commit summary for submodules in index or working tree
555#
556# If '--cached' is given, show summary between index and given commit,
557# or between working tree and given commit
558#
559# $@ = [commit (default 'HEAD'),] requested paths (default all)
560#
561cmd_summary() {
f2dc06a3 562 summary_limit=-1
d0f64dd4 563 for_status=
1c244f6e 564 diff_cmd=diff-index
f2dc06a3 565
28f9af5d
PY
566 # parse $args after "submodule ... summary".
567 while test $# -ne 0
568 do
569 case "$1" in
570 --cached)
571 cached="$1"
572 ;;
1c244f6e
JL
573 --files)
574 files="$1"
575 ;;
d0f64dd4
PY
576 --for-status)
577 for_status="$1"
578 ;;
f2dc06a3
PY
579 -n|--summary-limit)
580 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
581 then
582 :
583 else
584 usage
585 fi
586 shift
587 ;;
28f9af5d
PY
588 --)
589 shift
590 break
591 ;;
592 -*)
593 usage
594 ;;
595 *)
596 break
597 ;;
598 esac
599 shift
600 done
bffe71f4 601
f2dc06a3
PY
602 test $summary_limit = 0 && return
603
3deea89c 604 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
605 then
606 head=$rev
caa9c3ca 607 test $# = 0 || shift
3deea89c
JH
608 elif test -z "$1" -o "$1" = "HEAD"
609 then
14e940d7
JH
610 # before the first commit: compare with an empty tree
611 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 612 test -z "$1" || shift
28f9af5d 613 else
3deea89c 614 head="HEAD"
28f9af5d
PY
615 fi
616
1c244f6e
JL
617 if [ -n "$files" ]
618 then
619 test -n "$cached" &&
b9b9c22f 620 die "$(gettext -- "--cached cannot be used with --files")"
1c244f6e
JL
621 diff_cmd=diff-files
622 head=
623 fi
624
28f9af5d
PY
625 cd_to_toplevel
626 # Get modified modules cared by user
18076502 627 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 628 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
629 while read mod_src mod_dst sha1_src sha1_dst status name
630 do
631 # Always show modules deleted or type-changed (blob<->module)
632 test $status = D -o $status = T && echo "$name" && continue
633 # Also show added or modified modules which are checked out
634 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
635 echo "$name"
636 done
637 )
1cb639e6 638
d0f64dd4
PY
639 test -z "$modules" && return
640
18076502 641 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 642 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
643 cut -c2- |
644 while read mod_src mod_dst sha1_src sha1_dst status name
645 do
646 if test -z "$cached" &&
647 test $sha1_dst = 0000000000000000000000000000000000000000
648 then
649 case "$mod_dst" in
650 160000)
651 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
652 ;;
653 100644 | 100755 | 120000)
654 sha1_dst=$(git hash-object $name)
655 ;;
656 000000)
657 ;; # removed
658 *)
659 # unexpected type
dc2204fe
ÆAB
660 (
661 eval_gettext "unexpected mode \$mod_dst" &&
662 echo
663 ) >&2
1cb639e6
PY
664 continue ;;
665 esac
666 fi
667 missing_src=
668 missing_dst=
669
670 test $mod_src = 160000 &&
30353a40 671 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
672 missing_src=t
673
674 test $mod_dst = 160000 &&
30353a40 675 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 676 missing_dst=t
bffe71f4 677
1cb639e6
PY
678 total_commits=
679 case "$missing_src,$missing_dst" in
680 t,)
681 errmsg=" Warn: $name doesn't contain commit $sha1_src"
682 ;;
683 ,t)
684 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
685 ;;
686 t,t)
687 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
688 ;;
689 *)
690 errmsg=
691 total_commits=$(
692 if test $mod_src = 160000 -a $mod_dst = 160000
693 then
694 range="$sha1_src...$sha1_dst"
695 elif test $mod_src = 160000
696 then
697 range=$sha1_src
698 else
699 range=$sha1_dst
700 fi
701 GIT_DIR="$name/.git" \
b0e621ad 702 git rev-list --first-parent $range -- | wc -l
1cb639e6 703 )
eed35595 704 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
705 ;;
706 esac
707
708 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
709 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
710 if test $status = T
711 then
712 if test $mod_dst = 160000
713 then
714 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
715 else
716 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
717 fi
718 else
719 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
720 fi
721 if test -n "$errmsg"
722 then
723 # Don't give error msg for modification whose dst is not submodule
724 # i.e. deleted or changed to blob
725 test $mod_dst = 160000 && echo "$errmsg"
726 else
727 if test $mod_src = 160000 -a $mod_dst = 160000
728 then
f2dc06a3
PY
729 limit=
730 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 731 GIT_DIR="$name/.git" \
f2dc06a3 732 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
733 --first-parent $sha1_src...$sha1_dst
734 elif test $mod_dst = 160000
735 then
736 GIT_DIR="$name/.git" \
737 git log --pretty='format: > %s' -1 $sha1_dst
738 else
739 GIT_DIR="$name/.git" \
740 git log --pretty='format: < %s' -1 $sha1_src
741 fi
742 echo
743 fi
744 echo
d0f64dd4
PY
745 done |
746 if test -n "$for_status"; then
f17a5d34 747 if [ -n "$files" ]; then
165119e9 748 gettext "# Submodules changed but not updated:"; echo
f17a5d34 749 else
165119e9 750 gettext "# Submodule changes to be committed:"; echo
f17a5d34 751 fi
d0f64dd4
PY
752 echo "#"
753 sed -e 's|^|# |' -e 's|^# $|#|'
754 else
755 cat
756 fi
28f9af5d 757}
70c7ac22 758#
941987a5 759# List all submodules, prefixed with:
70c7ac22
LH
760# - submodule not initialized
761# + different revision checked out
762#
763# If --cached was specified the revision in the index will be printed
764# instead of the currently checked out revision.
765#
766# $@ = requested paths (default to all)
767#
23a485e3 768cmd_status()
70c7ac22 769{
5c08dbbd 770 # parse $args after "submodule ... status".
98dbe63d 771 orig_flags=
5c08dbbd
JH
772 while test $# -ne 0
773 do
774 case "$1" in
775 -q|--quiet)
2e6a30ef 776 GIT_QUIET=1
5c08dbbd
JH
777 ;;
778 --cached)
779 cached=1
780 ;;
64b19ffe
JH
781 --recursive)
782 recursive=1
783 ;;
5c08dbbd
JH
784 --)
785 shift
786 break
787 ;;
788 -*)
789 usage
790 ;;
791 *)
792 break
793 ;;
794 esac
98dbe63d 795 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
5c08dbbd
JH
796 shift
797 done
798
a7b3269c 799 module_list "$@" |
70c7ac22
LH
800 while read mode sha1 stage path
801 do
941987a5 802 name=$(module_name "$path") || exit
5be60078 803 url=$(git config submodule."$name".url)
64b19ffe 804 displaypath="$prefix$path"
313ee0d6
NMC
805 if test "$stage" = U
806 then
807 say "U$sha1 $displaypath"
808 continue
809 fi
ba88a1fe 810 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
70c7ac22 811 then
64b19ffe 812 say "-$sha1 $displaypath"
70c7ac22
LH
813 continue;
814 fi
41c7c1bd 815 set_name_rev "$path" "$sha1"
18076502 816 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
70c7ac22 817 then
64b19ffe 818 say " $sha1 $displaypath$revname"
70c7ac22
LH
819 else
820 if test -z "$cached"
821 then
74ae1419 822 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
41c7c1bd 823 set_name_rev "$path" "$sha1"
70c7ac22 824 fi
64b19ffe
JH
825 say "+$sha1 $displaypath$revname"
826 fi
827
828 if test -n "$recursive"
829 then
830 (
831 prefix="$displaypath/"
74ae1419 832 clear_local_git_env
64b19ffe 833 cd "$path" &&
a7eff1a8 834 eval cmd_status "$orig_args"
64b19ffe 835 ) ||
497ee872 836 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
70c7ac22
LH
837 fi
838 done
839}
2327f61e
DA
840#
841# Sync remote urls for submodules
842# This makes the value for remote.$remote.url match the value
843# specified in .gitmodules.
844#
845cmd_sync()
846{
847 while test $# -ne 0
848 do
849 case "$1" in
850 -q|--quiet)
2e6a30ef 851 GIT_QUIET=1
2327f61e
DA
852 shift
853 ;;
854 --)
855 shift
856 break
857 ;;
858 -*)
859 usage
860 ;;
861 *)
862 break
863 ;;
864 esac
865 done
866 cd_to_toplevel
867 module_list "$@" |
868 while read mode sha1 stage path
869 do
870 name=$(module_name "$path")
871 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
872
873 # Possibly a url relative to parent
874 case "$url" in
875 ./*|../*)
876 url=$(resolve_relative_url "$url") || exit
877 ;;
878 esac
879
8f3f2c44 880 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
33f072f8
AK
881 git config submodule."$name".url "$url"
882
2327f61e
DA
883 if test -e "$path"/.git
884 then
885 (
74ae1419 886 clear_local_git_env
2327f61e
DA
887 cd "$path"
888 remote=$(get_default_remote)
2327f61e
DA
889 git config remote."$remote".url "$url"
890 )
891 fi
892 done
893}
70c7ac22 894
5c08dbbd
JH
895# This loop parses the command line arguments to find the
896# subcommand name to dispatch. Parsing of the subcommand specific
897# options are primarily done by the subcommand implementations.
898# Subcommand specific options such as --branch and --cached are
899# parsed here as well, for backward compatibility.
900
901while test $# != 0 && test -z "$command"
70c7ac22
LH
902do
903 case "$1" in
2327f61e 904 add | foreach | init | update | status | summary | sync)
5c08dbbd 905 command=$1
70c7ac22
LH
906 ;;
907 -q|--quiet)
2e6a30ef 908 GIT_QUIET=1
70c7ac22 909 ;;
ecda0723
SV
910 -b|--branch)
911 case "$2" in
912 '')
913 usage
914 ;;
915 esac
916 branch="$2"; shift
917 ;;
70c7ac22 918 --cached)
28f9af5d 919 cached="$1"
70c7ac22
LH
920 ;;
921 --)
922 break
923 ;;
924 -*)
925 usage
926 ;;
927 *)
928 break
929 ;;
930 esac
931 shift
932done
933
5c08dbbd
JH
934# No command word defaults to "status"
935test -n "$command" || command=status
936
937# "-b branch" is accepted only by "add"
938if test -n "$branch" && test "$command" != add
939then
ecda0723 940 usage
5c08dbbd
JH
941fi
942
28f9af5d
PY
943# "--cached" is accepted only by "status" and "summary"
944if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 945then
70c7ac22 946 usage
5c08dbbd
JH
947fi
948
949"cmd_$command" "$@"